// Palette of GP blocks by class

to openBlocksPalette page {
  pal = (newMethodsPalette)
  setPosition (morph pal) (x (hand page)) (y (hand page))
  addPart page pal
  return pal
}

defineClass MethodsPalette morph window classListFrame blocksPane blocksFrame

to newMethodsPalette {
  result = (new 'MethodsPalette')
  initialize result
  return result
}

method initialize MethodsPalette {
  scale = (global 'scale')
  window = (window 'Methods Palette')
  clr = (clientColor window)
  morph = (morph window)
  setHandler morph this
  setMinExtent morph (scale * 300) (scale * 200)

  classList = (listBox (sortedClasses this) 'className' (action 'selectClass' this) clr (action 'openClassBrowser' this))
  classListFrame = (scrollFrame classList clr)
  addPart morph (morph classListFrame)

  blocksPane = (newBlocksPalette)
  blocksFrame = (scrollFrame blocksPane (gray 220))
  addPart morph (morph blocksFrame)

  setExtent morph (scale * 400) (scale * 200)
}

method sortedClasses MethodsPalette {
  classList = (list)
  for c (classes) {
    if ((count (methods c)) > 0) { add classList c }
  }
  return (sorted (toArray classList) (function c1 c2 { return ((className c1) < (className c2)) }))
}

method browse MethodsPalette aClass {
  select (contents classListFrame) aClass
  m = (selectedMorph (contents classListFrame))
  if (notNil m) { scrollIntoView classListFrame (bounds m) }
}

method selectClass MethodsPalette aClass {
  removeAllParts (morph blocksPane)
  for m (methods aClass) {
    b = (morph (blockForSpec (blockSpecFor m)))
    setGrabRule b 'template'
    addPart (morph blocksPane) b
  }
  cleanUp blocksPane
}

method redraw MethodsPalette {
  fixLayout window
  redraw window
  fixLayout this
}

method openClassBrowser MethodsPalette aClass {
  page = (page morph)
  brs = (newClassBrowser)
  setPosition (morph brs) (x (hand page)) (y (hand page))
  addPart page brs
  browse brs aClass
}

method fixLayout MethodsPalette {
  classesWidth = (action 'spaceBoundedBy' window (action 'allWidth' (contents classListFrame)) 25)
  packer = (newPanePacker (clientArea window))
  packPanesH packer classListFrame classesWidth blocksFrame 'rest'
  packPanesV packer classListFrame 'rest'
  packPanesV packer blocksFrame 'rest'
  finishPacking packer
}
