// operations that call functions on arrays and lists

to map func values {
  comment '
	Return an array with the result of calling
	the given function on each element of values.'
  result = (newArray (count values))
  for i (count values) {
    atPut result i (call func (at values i))
  }
  return result
}

to filter func values {
  comment '
	Return an array or list containing only those elements
	of values for which the function returns true.'
  result = (list)
  for i (count values) {
    v = (at values i)
    if (call func v) { add result v }
  }
  if (isClass values 'Array') { result = (toArray result) }
  return result
}

to detect func values valueIfNotFound {
  comment '
	Return the first element for which the function returns true.
	Otherwise, return valueIfNotFound.'
  for i (count values) {
    v = (at values i)
    if (call func v) { return v }
  }
  return valueIfNotFound
}

to reduce func values valueIfEmpty {
  comment '
	Combime all elements with a two-argument function.
	If values is empty, return valueIfEmpty.'
  if ((count values) == 0) { return valueIfEmpty }
  for i (count values) {
    if (i == 1) {
      result = (at values i)
    } else {
      result = (call func result (at values i))
    }
  }
  return result
}
